/*******************************************************************************
 *	@file			Net.cpp
 *	@brief			Network Library
 *
 *	@author			ohwhsmm7
 *
 *	@date			12-Nov-2011(Sat)
 ******************************************************************************/

// vvZbT---------------------------------------------------------------
#include "Net.h"
#include "TCP.h"

/*******************************************************************************
 *	@namespace	NET
 ******************************************************************************/
namespace	NET
{

// O[oϐ-----------------------------------------------------------
NET::CTCP				g_CTCP;													//!< TCP

// ֐vg^Cv錾-----------------------------------------------------

// -----------------------------------------------------------------------------
/*******************************************************************************
 *	@fn				void* SetupTCP( const BOOL& bServer,
 *									const BOOL& bClient,
 *									const int& nMember,
 *									const char* cAddr,
 *									const char* cPort )
 *	@param[in]		bServer						TCP T[o[gptO
 *	@param[in]		bClient						TCP NCAggptO
 *	@param[in]		nMember						Ql
 *	@retval			void*						NET::CTCP
 *	@brief			NET::CTCP̐ݒ
 ******************************************************************************/
void* SetupTCP( const BOOL& bServer,
				const BOOL& bClient,
				const int& nMember,
				const char* cAddr,
				const char* cPort )
{
	assert( ( nMember >= 0 ) && "SetupTCP" );
	assert( ( ::strcmp( cAddr, "" ) != 0 ) && "SetupTCP" );
	assert( ( ::strcmp( cPort, "" ) != 0 ) && "SetupTCP" );

	STCP tcp;
	tcp.m_bServer = bServer;
	tcp.m_bClient = bClient;
	tcp.m_nMemMax = nMember + 1;												//!< +1Ŏǉ
	tcp.m_sAddr = cAddr;
	tcp.m_sPort = cPort;
	g_CTCP.SetTCP( tcp );

	return reinterpret_cast<void*>( &g_CTCP );
}

/*******************************************************************************
 *	@fn				BOOL Init( void )
 *	@retval			BOOL						TRUE=OK/FALSE=NG
 *	@brief			
 ******************************************************************************/
BOOL Init( void )
{
	WSADATA wsaData;
	// winsock2̏
	if( ::WSAStartup( MAKEWORD( 2, 0 ), &wsaData ) != 0 ) return FALSE;

	// TCP̏
	if( !g_CTCP.Init() ) return FALSE;

	return TRUE;
}

/*******************************************************************************
 *	@fn				void End( void )
 *	@retval			none						Ȃ
 *	@brief			I
 ******************************************************************************/
void End( void )
{
	// TCP̏I
	g_CTCP.End();

	// winsock2̏I
	::WSACleanup();
}

}	// namespace	NET
