/*******************************************************************************
 *	@file			TCP.cpp
 *	@brief			Network Library
 *
 *	@author			ohwhsmm7
 *
 *	@date			30-Dec-2011(Fri)
 ******************************************************************************/

// vvZbT---------------------------------------------------------------
#include "TCP.h"

/*******************************************************************************
 *	@namespace	NET
 ******************************************************************************/
namespace	NET
{

// O[oϐ-----------------------------------------------------------

// ֐vg^Cv錾-----------------------------------------------------

// -----------------------------------------------------------------------------
/*******************************************************************************
 *	@fn				CTCP::AcceptThread( void *p )
 *	@param[in]		p							ėp
 *	@retval			unsigned					TRUE
 *	@brief			FؗpXbh
 ******************************************************************************/
unsigned __stdcall CTCP::AcceptThread( void *p )
{
	CTCP *pTCP = reinterpret_cast<CTCP*>( p );

	// TCP/IP\Pbg̍쐬
	SOCKET Sock;
	Sock = ::WSASocket( AF_INET, SOCK_STREAM, IPPROTO_TCP, NULL, 0, 0 );
	if( Sock == INVALID_SOCKET )
	{
		assert( 0 && "AtteThread : WSASocket()" );
		goto ERROR_THREAD;
	}

	// ڑT[o[̃AhXݒ
	SOCKADDR_IN sa_in;
	sa_in.sin_family			= AF_INET;
	sa_in.sin_addr.S_un.S_addr	= ::inet_addr( pTCP->m_STcp.m_sAddr.c_str() );
	sa_in.sin_port				= ::htons( ::atoi( pTCP->m_STcp.m_sPort.c_str() ) );

	// 쐬\PbgɃAhXƃ|[g֘At
	if( ::bind( Sock, reinterpret_cast<SOCKADDR*>( &sa_in ), sizeof( SOCKADDR ) ) != 0 )
	{
		assert( 0 && "AtteThread : bind()" );
		goto ERROR_THREAD;
	}

	// TCPNCAg̐ڑv҂Ԃɐݒ
	if( ::listen( Sock, SOMAXCONN ) != 0 )
	{
		assert( 0 && "AtteThread : listen()" );
		goto ERROR_THREAD;
	}

	pTCP->SetLog( "TCP/IP T[o[ւ̐ڑ҂Jn" );
	// [vŐڑv҂
	while( 1 )
	{
		SOCKET Socket;

		// ACCEPT
		// TCPNCAg̐ڑv󂯕t
		SOCKADDR_IN sa_out;
		int nLen = sizeof( SOCKADDR_IN );
		Socket = ::WSAAccept( Sock, reinterpret_cast<SOCKADDR*>( &sa_out ), &nLen, NULL, NULL );
		if( Socket == INVALID_SOCKET )
		{
			assert( 0 && "AtteThread : WSAAccept()" );
			continue;
		}
		if( SOCKET_ERROR == ::WSAGetLastError() )
		{
			assert( 0 && "AtteThread : WSAAccept()" );
			continue;
		}

		// ڑĂAhXg̏ꍇAIƂ݂Ȃ[vEo
		if( ::strcmp( pTCP->m_STcp.m_sAddr.c_str(), ::inet_ntoa( sa_out.sin_addr ) ) == 0 )
		{
			::closesocket( Socket );
			break;
		}

		// WSAAccept() őҋ@AԂsvǔÔ
		::Sleep( 100 );
	}

ERROR_THREAD:
	::closesocket( Sock );

	::_endthreadex( 0 );
	return TRUE;
}

/*******************************************************************************
 *	@fn				CTCP::ConnectThread( void *p )
 *	@param[in]		p							ėp
 *	@retval			unsigned					TRUE
 *	@brief			ڑpXbh
 ******************************************************************************/
unsigned __stdcall CTCP::ConnectThread( void *p )
{
	CTCP *pTCP = reinterpret_cast<CTCP*>( p );

	// TCP/IP\Pbg̍쐬
	SOCKET Sock = ::WSASocket( AF_INET, SOCK_STREAM, IPPROTO_TCP, NULL, 0, 0 );
	if( Sock == INVALID_SOCKET )
	{
		assert( 0 && "ConnectThread : WSASocket()" );
		goto ERROR_THREAD;
	}

	// ڑT[o[̃AhXݒ
	SOCKADDR_IN sa_in;
	sa_in.sin_family			= AF_INET;
	sa_in.sin_addr.S_un.S_addr	= ::inet_addr( pTCP->m_STcp.m_sAddr.c_str() );
	sa_in.sin_port				= ::htons( ::atoi( pTCP->m_STcp.m_sPort.c_str() ) );

	// CONNECT
	int nRes = ::WSAConnect( Sock, reinterpret_cast<SOCKADDR*>( &sa_in ), sizeof( sa_in ), NULL, NULL, NULL, NULL );
	if( nRes != SOCKET_ERROR )
	{
		pTCP->SetLog( "TCP/IP T[o[ɐڑ܂" );
	}else
		pTCP->SetLog( "TCP/IP T[o[ւ̐ڑɎs" );

ERROR_THREAD:
	::closesocket( Sock );

	::_endthreadex( 0 );
	return TRUE;
}

/*******************************************************************************
 *	@fn				CTCP::CTCP( void )
 *	@retval			none						Ȃ
 *	@brief			RXgN^
 ******************************************************************************/
CTCP::CTCP( void )
	: m_STcp()
{
}

/*******************************************************************************
 *	@fn				CTCP::~CTCP( void )
 *	@retval			none						Ȃ
 *	@brief			fXgN^
 ******************************************************************************/
CTCP::~CTCP( void )
{
}

/*******************************************************************************
 *	@fn				void CTCP::CTCP( const STCP& STcp )
 *	@param[in]		STCP						\
 *	@retval			none						Ȃ
 *	@brief			ZbgAbv\̐ݒ
 ******************************************************************************/
void CTCP::SetTCP( const STCP& STcp )
{
	m_STcp = STcp;
}

/*******************************************************************************
 *	@fn				int CTCP::Init( void )
 *	@retval			int							TRUE=OK/FALSE=NG
 *	@brief			
 ******************************************************************************/
int CTCP::Init( void )
{
	unsigned int uiID;
	HANDLE hID;

	// TCPT[o[gp
	if( m_STcp.m_bServer )
	{
		SetLog( "TCP/IP T[o[Jn" );
		hID = reinterpret_cast<HANDLE>( ::_beginthreadex( NULL, 0, &CTCP::AcceptThread, this, 0, &uiID ) );
		::CloseHandle( hID );
	}
	// TCPNCAggp
	if( m_STcp.m_bClient )
	{
		SetLog( "TCP/IP NCAgJn" );
		hID = reinterpret_cast<HANDLE>( ::_beginthreadex( NULL, 0, &CTCP::ConnectThread, this, 0, &uiID ) );
		::CloseHandle( hID );
	}

	return TRUE;
}

/*******************************************************************************
 *	@fn				int CTCP::End( void )
 *	@retval			int							TRUE=OK/FALSE=NG
 *	@brief			I
 *					ׂẴXbhI
 ******************************************************************************/
int CTCP::End( void )
{
	// TCPT[o[gp
	if( m_STcp.m_bServer )
	{
		// őgݍ
		// TCP/IP\Pbg̍쐬
		SOCKET Sock = ::WSASocket( AF_INET, SOCK_STREAM, IPPROTO_TCP, NULL, 0, 0 );

		// ڑT[o[̃AhXݒ
		SOCKADDR_IN sa_in;
		sa_in.sin_family			= AF_INET;
		sa_in.sin_addr.S_un.S_addr	= ::inet_addr( m_STcp.m_sAddr.c_str() );
		sa_in.sin_port				= ::htons( ::atoi( m_STcp.m_sPort.c_str() ) );

		// ɐڑ
		int nRes = ::WSAConnect( Sock, reinterpret_cast<SOCKADDR*>( &sa_in ), sizeof( sa_in ), NULL, NULL, NULL, NULL );

		// Ô߂Pbҋ@
		::Sleep( 1000 );

		// TCPZbV̏I
		::closesocket( Sock );

		SetLog( "TCP/IP T[o[I" );
	}

	return TRUE;
}

}	// namespace	NET
